using System.Collections.Generic;
using WingServerCommon.Utilities.Executors;
using WingServerCommon.Log;
namespace ReportService.Posters
{
    /// <summary>
    /// TODO Move to database
    /// </summary>
    public interface IReportDbService
    {

    }

    public enum ReportFormat
    {
        Json,
        Xml
    }
    public interface IReportPosterSettings
    {
        string ReceiverName {get;set;}
        string TargetUrl {get;set;}
        ReportFormat  ReportFormat {get;set;}

    }

    public interface IReportInfo
    {
        string Id {get;set;} 
        string PatientId {get;set;} 

    }

    public class ReportPoster
    {
        readonly IReportPosterSettings _settings;
        readonly SequenceExecutor<IReportInfo> _reportPostExetutor;
        
        public ReportPoster(IReportPosterSettings settings, string deviceId)
        {
            _reportPostExetutor = new SequenceExecutor<IReportInfo>("Poster-"+ deviceId);
            _settings = settings;
        }

        public void Post(IReportInfo reportInfo)
        {
            _reportPostExetutor.Add(DoPost, reportInfo);
        }

        bool DoPost(IReportInfo reportInfo)
        {
            try{
                Logger.WriteLineInfo($"Begin to post report {reportInfo.Id} with patieentId {reportInfo.PatientId}");

            }
            catch
            {                
            }

            return true;
        }
    }

    public class ReportPostCenter
    {
        readonly IReportDbService _dbService;
        readonly Dictionary<string, ReportPoster> _posters = new Dictionary<string, ReportPoster>();
        public ReportPostCenter(IReportDbService dbService)
        {
            _dbService = dbService;
            LoadPosterSettings();
        }

        void LoadPosterSettings()
        {
            //TODO
        }        

        public void Add()
        {

        }

        /// <summary>
        /// Remove a report poster 
        /// </summary>
        /// <param name="id"></param>
        public void Remove(string id)
        {
        }

        public void Post(string deviceId, IReportInfo reportInfo)
        {
            if (_posters.ContainsKey(deviceId))
            {
                _posters[deviceId].Post(reportInfo);
            }
            else
            {
                Logger.WriteLineWarn($"Not found report post for device:{deviceId}");
            }

        }
    }
}